<?php	if( !defined( 'BILLING_MODULE' ) ) die( "Hacking attempt!" );

Class PAYSYS
{
	var $doc = "https://finpay-api.gitbook.io/finpay/";
	
	function Settings($config) 
	{
		$html = array();
		
        $html[] = array(
            'ID Магазина',
            'Используется для идентификации в API и форме оплаты',
            '<input name="save_con[merchant_id]" class="form-control" type="text" value="' . $config['merchant_id'] . '" style="width: 100%">',
        );
		
        $html[] = array(
            'Secret 1',
            'Секретный ключ для формы оплаты',
            '<input name="save_con[secret1]" class="form-control" type="text" value="' . $config['secret1'] . '" style="width: 100%">',
        );
		
        $html[] = array(
            'Secret 2',
            'Секретный ключ для обработчика',
            '<input name="save_con[secret2]" class="form-control" type="text" value="' . $config['secret2'] . '" style="width: 100%">',
        );
		
        $html[] = [
            'Страны',
            'Используется на сайте FinPay',
            '<select name="save_con[currency]" class="form-control uniform">
				<option value="ru" ' . ($config['currency'] == 'ru' ? 'selected' : '') . '>RU</option>
				<option value="ua" ' . ($config['currency'] == 'ua' ? 'selected' : '') . '>UAH</option>
				<option value="uz" ' . ($config['currency'] == 'uz' ? 'selected' : '') . '>UZ</option>
				<option value="kz" ' . ($config['currency'] == 'kz' ? 'selected' : '') . '>KZ</option>
				<option value="az" ' . ($config['currency'] == 'az' ? 'selected' : '') . '>AZ</option>
				<option value="kg" ' . ($config['currency'] == 'kg' ? 'selected' : '') . '>KG</option>
			</select>',
        ];

		return $html;
	}

	function form($id, $config, $invoice, $desc, $DevTools) 
	{
		if($config['merchant_id'] == '' || $config['secret1'] == '' || $config['secret2'] == '' || $config['currency'] == '') {
			return "Платежная система FinPay не настроена!";
		}
		
		$invoice['invoice_pay'] = (int)($invoice['invoice_pay'] * 100);
		
		$desc = 'Invoice #' . $id; // Описание платежа
		$method_id = 'card_cis';
        $sign = hash('md5', implode(':', [$config['merchant_id'], $id, $invoice['invoice_pay'], $method_id, $config['secret1']]));

		$url = "https://api.finpay.llc/payments";

		$data = array(
			"shop_id" => $config['merchant_id'],
			"invoice_id" => $id,
			"description" => "Оплата счета ".$id,
			"amount" => $invoice['invoice_pay'],
			"method" => $method_id,
			"country" => "RU",
			"currency" => $config['currency'],
			"signature" => $sign
		);

		$headers = array(
			"Content-Type: application/json"
		);

		$ch = curl_init();
					
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

		$response = curl_exec($ch);
					
		if(curl_errno($ch)){
			echo 'Произошла ошибка: ' . curl_error($ch);
		}
					
		$decodedResponse = json_decode($response, true);
  
		return '
			<form method="POST" action="' . $decodedResponse['url'] . '" id="paysys_form">				
				<input type="submit" class="btn" value="Оплатить">
			</form>
		';
	}
	
	function check_id($DATA) 
	{
		return $DATA["invoice_id"];
	}
	
	function check_ok($DATA) 
	{
		return $DATA['invoice_id'] . '|success';
	}
	
	function check_out($data, $config, $invoice)
	{
		$ip = $_SERVER['REMOTE_ADDR'];
		if (isset($_SERVER['HTTP_CF_CONNECTING_IP'])) $ip = $_SERVER['HTTP_CF_CONNECTING_IP'];
		if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
		if (isset($_SERVER['HTTP_X_REAL_IP'])) $ip = $_SERVER['HTTP_X_REAL_IP'];
		
		if($_POST['amount'] < $invoice['invoice_pay']) {
			die("wrong amount");
		}
		
        return 200;
	}
}

$Paysys = new PAYSYS;
?>